# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define section free
%define oname wicket

Summary:        Wicket webapp framework
Name:           wicket13
Version:        1.3.7
Release:        2%{?dist}
Epoch:          0
Group:          Development/Framework
License:        ASL 2.0
URL:            http://wicket.apache.org/
Source0:        http://www.apache.org/dist/wicket/1.3.7/apache-wicket-1.3.7.tar.gz
Source1:        %{name}-jpp-depmap.xml
Source2:        %{name}-settings.xml
Patch0:         wicket13-pom.patch
Patch1:         wicket13-jdk1.4-wicket-pom.patch
Patch2:         wicket13-spring-ApplicationContextMock.patch
Patch3:         wicket13-velocity-pom.patch
Patch4:         wicket13-examples-httpunit-ParsedHTML.patch
Patch5:         wicket13-quickstart-archetype-pom.patch
Patch6:         wicket13-ResourceTestPage.patch
Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5
Requires:       java >= 0:1.6.0
Requires:       apache-portlet-1.0-api
Requires:       apache-commons-collections
Requires:       portals-bridges1-common
Requires:       log4j >= 0:1.2.14
Requires:       slf4j
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  junit
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-skins
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-eclipse
BuildRequires:  maven2-plugin-gpg
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-project-info-reports
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-war
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven-surefire-report-maven-plugin
BuildRequires:  felix-maven2
BuildRequires:  jetty6-maven2-plugins
BuildRequires:  apache-portlet-1.0-api
BuildRequires:  asm
BuildRequires:  excalibur-avalon-framework
BuildRequires:  excalibur-avalon-logkit
BuildRequires:  cglib
BuildRequires:  easymock-java5
BuildRequires:  google-guice
BuildRequires:  httpunit16
BuildRequires:  jetty6-core
BuildRequires:  jetty6-management
BuildRequires:  apache-commons-collections
BuildRequires:  apache-commons-httpclient
BuildRequires:  apache-commons-lang
BuildRequires:  apache-commons-logging
BuildRequires:  jhighlight
BuildRequires:  joda-time
BuildRequires:  log4j
BuildRequires:  portals-bridges1-common
BuildRequires:  apache-portlet-1.0-api
BuildRequires:  servlet_2_5_api
BuildRequires:  slf4j
BuildRequires:  spring2-all
BuildRequires:  velocity14
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
With proper mark-up/logic separation, a POJO data model, and
a refreshing lack of XML, Apache Wicket makes developing 
web-apps simple and enjoyable again. Swap the boilerplate, 
complex debugging and brittle code for powerful, reusable 
components written with plain Java and HTML.

%package datetime
Group:          Development/Framework
Summary:        Datetime module for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       joda-time

%description datetime
%{summary}.

%package ioc
Group:          Development/Framework
Summary:        IoC module for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       cglib

%description ioc
%{summary}.

%package spring
Group:          Development/Framework
Summary:        Spring module for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       %{name}-ioc = %{epoch}:%{version}-%{release}
Requires:       spring

%description spring
%{summary}.

%package velocity
Group:          Development/Framework
Summary:        Velocity module for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       apache-commons-collections
Requires:       velocity14

%description velocity
%{summary}.

%package guice
Group:          Development/Framework
Summary:        Guice module for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       %{name}-ioc = %{epoch}:%{version}-%{release}
Requires:       google-guice

%description guice
%{summary}.

%package threadtest
Group:          Development/Framework
Summary:        Threadtest module for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       apache-commons-httpclient
Requires:       jetty6-core
Requires:       slf4j

%description threadtest
%{summary}.

%package demo
Group:          Development/Framework
Summary:        Examples for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       %{name}-datetime = %{epoch}:%{version}-%{release}
Requires:       %{name}-guice = %{epoch}:%{version}-%{release}
Requires:       %{name}-velocity = %{epoch}:%{version}-%{release}
Requires:       httpunit16
Requires:       apache-commons-lang
Requires:       jetty6-core
Requires:       jetty6-management
Requires:       jhighlight
Requires:       apache-portlet-1.0-api
Requires:       slf4j
Requires:       velocity14

%description demo
%{summary}.

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description javadoc
%{summary}.

%prep
%setup -q -n apache-%{oname}-%{version}
find . -name "*.jar" | xargs -t rm
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3
%patch4 -b .sav4
%patch5 -b .sav5
%patch6 -b .sav6

cp %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository

cd src
mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.failure.ignore=true \
        install javadoc:aggregate
#       -Dmaven.test.skip=true \

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 src/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-parent.pom
%add_to_maven_depmap org.apache.wicket wicket-parent %{version} JPP/%{name} parent

install -m 644 src/archetypes/quickstart/target/wicket-archetype-quickstart-%{version}.jar \
         $RPM_BUILD_ROOT%{_javadir}/%{name}/archetype-quickstart-%{version}.jar
install -m 644 src/archetypes/quickstart/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-archetype-quickstart.pom
%add_to_maven_depmap org.apache.wicket wicket-archetype-quickstart %{version} JPP/%{name} archetype-quickstart

install -m 644 src/jdk-1.4/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jdk14.pom
%add_to_maven_depmap org.apache.wicket wicket-jdk14 %{version} JPP/%{name} jdk14

install -m 644 src/jdk-1.4/wicket-datetime/target/wicket-datetime-%{version}.jar \
         $RPM_BUILD_ROOT%{_javadir}/%{name}/datetime-%{version}.jar
install -m 644 src/jdk-1.4/wicket-datetime/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-datetime.pom
%add_to_maven_depmap org.apache.wicket wicket-datetime %{version} JPP/%{name} datetime

install -m 644 src/jdk-1.4/wicket-extensions/target/wicket-extensions-%{version}.jar \
         $RPM_BUILD_ROOT%{_javadir}/%{name}/extensions-%{version}.jar
install -m 644 src/jdk-1.4/wicket-extensions/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-extensions.pom
%add_to_maven_depmap org.apache.wicket wicket-extensions %{version} JPP/%{name} extensions

install -m 644 src/jdk-1.4/wicket-ioc/target/wicket-ioc-%{version}.jar \
         $RPM_BUILD_ROOT%{_javadir}/%{name}/ioc-%{version}.jar
install -m 644 src/jdk-1.4/wicket-ioc/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-ioc.pom
%add_to_maven_depmap org.apache.wicket wicket-ioc %{version} JPP/%{name} ioc

install -m 644 src/jdk-1.4/wicket/target/wicket-%{version}.jar \
         $RPM_BUILD_ROOT%{_javadir}/%{name}/wicket-%{version}.jar
install -m 644 src/jdk-1.4/wicket/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-wicket.pom
%add_to_maven_depmap org.apache.wicket wicket %{version} JPP/%{name} wicket

install -m 644 src/jdk-1.4/wicket-spring/target/wicket-spring-%{version}.jar \
         $RPM_BUILD_ROOT%{_javadir}/%{name}/spring-%{version}.jar
install -m 644 src/jdk-1.4/wicket-spring/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-spring.pom
%add_to_maven_depmap org.apache.wicket wicket-spring %{version} JPP/%{name} spring

install -m 644 src/jdk-1.4/wicket-velocity/target/wicket-velocity-%{version}.jar \
         $RPM_BUILD_ROOT%{_javadir}/%{name}/velocity-%{version}.jar
install -m 644 src/jdk-1.4/wicket-velocity/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-velocity.pom
%add_to_maven_depmap org.apache.wicket wicket-velocity %{version} JPP/%{name} velocity

install -m 644 src/jdk-1.5/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jdk15.pom
%add_to_maven_depmap org.apache.wicket wicket-jdk15 %{version} JPP/%{name} jdk15

install -m 644 src/jdk-1.5/wicket-auth-roles/target/wicket-auth-roles-%{version}.jar \
         $RPM_BUILD_ROOT%{_javadir}/%{name}/auth-roles-%{version}.jar
install -m 644 src/jdk-1.5/wicket-auth-roles/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-auth-roles.pom
%add_to_maven_depmap org.apache.wicket wicket-auth-roles %{version} JPP/%{name} auth-roles

install -m 644 src/jdk-1.5/wicket-guice/target/wicket-guice-%{version}.jar \
         $RPM_BUILD_ROOT%{_javadir}/%{name}/guice-%{version}.jar
install -m 644 src/jdk-1.5/wicket-guice/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-guice.pom
%add_to_maven_depmap org.apache.wicket wicket-guice %{version} JPP/%{name} guice

install -m 644 src/jdk-1.5/wicket-jmx/target/wicket-jmx-%{version}.jar \
         $RPM_BUILD_ROOT%{_javadir}/%{name}/jmx-%{version}.jar
install -m 644 src/jdk-1.5/wicket-jmx/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jmx.pom
%add_to_maven_depmap org.apache.wicket wicket-jmx %{version} JPP/%{name} jmx

install -m 644 src/jdk-1.5/wicket-objectssizeof-agent/target/wicket-objectsizeof-agent-%{version}.jar \
         $RPM_BUILD_ROOT%{_javadir}/%{name}/objectsizeof-agent-%{version}.jar
install -m 644 src/jdk-1.5/wicket-objectssizeof-agent/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-objectsizeof-agent.pom
%add_to_maven_depmap org.apache.wicket wicket-objectsizeof-agent %{version} JPP/%{name} objectsizeof-agent

install -m 644 src/jdk-1.5/wicket-spring-annot/target/wicket-spring-annot-%{version}.jar \
         $RPM_BUILD_ROOT%{_javadir}/%{name}/spring-annot-%{version}.jar
install -m 644 src/jdk-1.5/wicket-spring-annot/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-spring-annot.pom
%add_to_maven_depmap org.apache.wicket wicket-spring-annot %{version} JPP/%{name} spring-annot

install -m 644 src/testing/wicket-threadtest/target/wicket-threadtest-%{version}.jar \
         $RPM_BUILD_ROOT%{_javadir}/%{name}/threadtest-%{version}.jar
install -m 644 src/testing/wicket-threadtest/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-threadtest.pom
%add_to_maven_depmap org.apache.wicket wicket-threadtest %{version} JPP/%{name} threadtest

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -m 0644 src/jdk-1.4/wicket-quickstart/target/wicket-quickstart.war $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/%{name}-quickstart.war
install -m 0644 src/jdk-1.5/wicket-examples/target/wicket-examples.war $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/%{name}-examples.war

# javadoc
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr src/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/archetype-quickstart*.jar
%{_javadir}/%{name}/extensions*.jar
%{_javadir}/%{name}/wicket*.jar
%{_javadir}/%{name}/auth-roles*.jar
%{_javadir}/%{name}/jmx*.jar
%{_javadir}/%{name}/objectsizeof*.jar
%{_datadir}/maven2/poms/*
%dir %{_datadir}/%{name}-%{version}
%{_datadir}/%{name}-%{version}/%{name}-quickstart.war
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*-%{version}.jar.*
%endif

%files datetime
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/datetime*.jar

%files ioc
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/ioc*.jar

%files spring
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/spring*.jar

%files velocity
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/velocity*.jar

%files guice
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/guice*.jar

%files threadtest
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/threadtest*.jar

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}-%{version}/%{name}-examples.war

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Sun Feb 05 2012 Ralph Apel <r.apel@r-apel.de> 0:1.3.7-2
- Replace (B)R portals-bridges-common with portals-bridges1-common

* Wed Feb 02 2012 Ralph Apel <r.apel@r-apel.de> 0:1.3.7-1
- 1.3.7 as wicket13 for JPP-6

* Wed Jun 03 2009 David Walluck <dwalluck@redhat.com> 0:1.3.6-1
- 1.3.6

* Mon Aug 11 2008 Ralph Apel <r.apel at r-apel.de> 0:1.3.4-1.jpp5
- Initial release

